/*
 * A dictionnary
 *---
 * to my angel
 * public domain
 * march 2002
 */

#ifndef _STRINGS_H_
#define _STRINGS_H_

typedef unsigned long sid;

#include "hash.h"

typedef void user_context;
typedef void user_data;

typedef sid (*string_user_to_sid_function)(user_context *, user_data *);

typedef struct {
  hash_table ht;		/* the hash table */
  void *data;			/* the big array of strings */
  unsigned long size;		/* the size of the big array (in bytes) */
  unsigned long maxsize;	/* the maxsize of the big array (in bytes) */
  string_user_to_sid_function user_to_sid;
  user_context *user_to_sid_pointer;
} strings;

int init_strings(strings *, string_user_to_sid_function, user_context *, unsigned long);
void free_strings(strings *);

/* this one returns -2 if string already here, -1 if error, otherwise it sets sid and hid
 * to the new allocated string, sid and hid are set too if returns -2
 */
int string_new(strings *, char *, hid *, sid *);
/* must be called right after the previous one, with the hid returned */
void string_feed_slot(strings *, hid, void *);
void *string_get_slot(strings *, hid);
/* returns -1 if string not here, 0 if it is and set sid to the string found */
int string_search(strings *, char *, sid *, user_data **);

char *sid_to_string(strings *, sid);

/* default functions */
#define STRING_DEFAULT_USER_TO_SID (string_user_to_sid_function)string_user_to_sid
sid string_user_to_sid(strings *, sid *);

#endif /* _STRINGS_H_ */
